## stress-ng 0.05.23

=== Makefile ===
#
# Copyright (C) 2013-2016 Canonical, Ltd.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

VERSION=0.05.23
#
# Codename "dastardly determined distressor"
#

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

BINDIR=/usr/bin
MANDIR=/usr/share/man/man1

#
#  Stressors
#
STRESS_SRC = \
	stress-affinity.c \
	stress-af-alg.c \
	stress-aio.c \
	stress-aio-linux.c \
	stress-apparmor.c \
	stress-bigheap.c \
	stress-bind-mount.c \
	stress-brk.c \
	stress-bsearch.c \
	stress-cache.c \
	stress-cap.c \
	stress-chdir.c \
	stress-chmod.c \
	stress-clock.c \
	stress-clone.c \
	stress-context.c \
	stress-copy-file.c \
	stress-cpu.c \
	stress-cpu-online.c \
	stress-crypt.c \
	stress-daemon.c \
	stress-dentry.c \
	stress-dir.c \
	stress-dup.c \
	stress-epoll.c \
	stress-eventfd.c \
	stress-exec.c \
	stress-fallocate.c \
	stress-fault.c \
	stress-fcntl.c \
	stress-fiemap.c \
	stress-fifo.c \
	stress-filename.c \
	stress-flock.c \
	stress-fork.c \
	stress-fp-error.c \
	stress-fstat.c \
	stress-futex.c \
	stress-get.c \
	stress-getrandom.c \
	stress-getdent.c \
	stress-handle.c \
	stress-hdd.c \
	stress-heapsort.c \
	stress-hsearch.c \
	stress-icache.c \
	stress-inotify.c \
	stress-iosync.c \
	stress-itimer.c \
	stress-kcmp.c \
	stress-key.c \
	stress-kill.c \
	stress-klog.c \
	stress-lease.c \
	stress-lsearch.c \
	stress-link.c \
	stress-lockbus.c \
	stress-lockf.c \
	stress-longjmp.c \
	stress-malloc.c \
	stress-matrix.c \
	stress-membarrier.c \
	stress-memcpy.c \
	stress-memfd.c \
	stress-mergesort.c \
	stress-mincore.c \
	stress-mknod.c \
	stress-mlock.c \
	stress-mmap.c \
	stress-mmapfork.c \
	stress-mmapmany.c \
	stress-mremap.c \
	stress-msg.c \
	stress-mq.c \
	stress-nice.c \
	stress-noop.c \
	stress-null.c \
	stress-numa.c \
	stress-oom-pipe.c \
	stress-open.c \
	stress-personality.c \
	stress-pipe.c \
	stress-poll.c \
	stress-procfs.c \
	stress-pthread.c \
	stress-ptrace.c \
	stress-quota.c \
	stress-qsort.c \
	stress-rdrand.c \
	stress-readahead.c \
	stress-remap-file-pages.c \
	stress-rename.c \
	stress-rlimit.c \
	stress-seek.c \
	stress-seccomp.c \
	stress-sem.c \
	stress-sem-sysv.c \
	stress-sendfile.c \
	stress-shm.c \
	stress-shm-sysv.c \
	stress-sigfd.c \
	stress-sigfpe.c \
	stress-sigpending.c \
	stress-sigsegv.c \
	stress-sigsuspend.c \
	stress-sigq.c \
	stress-sleep.c \
	stress-socket.c \
	stress-socket-fd.c \
	stress-socketpair.c \
	stress-spawn.c \
	stress-splice.c \
	stress-stack.c \
	stress-str.c \
	stress-stream.c \
	stress-switch.c \
	stress-sync-file.c \
	stress-sysinfo.c \
	stress-sysfs.c \
	stress-tee.c \
	stress-timer.c \
	stress-timerfd.c \
	stress-tsc.c \
	stress-tsearch.c \
	stress-udp.c \
	stress-udp-flood.c \
	stress-unshare.c \
	stress-urandom.c \
	stress-userfaultfd.c \
	stress-utime.c \
	stress-vecmath.c \
	stress-vm.c \
	stress-vm-rw.c \
	stress-vm-splice.c \
	stress-wait.c \
	stress-wcstr.c \
	stress-xattr.c \
	stress-yield.c \
	stress-zero.c \
	stress-zlib.c \
	stress-zombie.c \

#
# Stress core
#
CORE_SRC = \
	cache.c \
	helper.c \
	ignite-cpu.c \
	io-priority.c \
	limit.c \
	log.c \
	madvise.c \
	mincore.c \
	mlock.c \
	mounts.c \
	mwc.c \
	net.c \
	out-of-memory.c \
	parse-opts.c \
	perf.c \
	sched.c \
	thermal-zone.c \
	time.c \
	stress-ng.c

SRC = $(STRESS_SRC) $(CORE_SRC)
OBJS = $(SRC:.c=.o)

APPARMOR_PARSER=/sbin/apparmor_parser

LIB_APPARMOR := -lapparmor
LIB_BSD := -lbsd
LIB_Z := -lz
LIB_CRYPT := -lcrypt
LIB_RT := -lrt
LIB_PTHREAD := -lpthread
LIB_AIO = -laio

HAVE_NOT=HAVE_APPARMOR=0 HAVE_KEYUTILS_H=0 HAVE_XATTR_H=0 HAVE_LIB_BSD=0 \
	 HAVE_LIB_Z=0 HAVE_LIB_CRYPT=0 HAVE_LIB_RT=0 HAVE_LIB_PTHREAD=0 \
	 HAVE_FLOAT_DECIMAL=0 HAVE_SECCOMP_H=0 HAVE_LIB_AIO=0 HAVE_SYS_CAP_H=0

#
# Do build time config only if cmd is "make" and no goals given
#
ifeq ($(MAKECMDGOALS),)
#
# A bit recursive, 2nd time around HAVE_APPARMOR is
# defined so we don't call ourselves over and over
#
ifndef $(HAVE_APPARMOR)
HAVE_APPARMOR = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_apparmor)
ifeq ($(HAVE_APPARMOR),1)
	OBJS += apparmor-data.o
	CFLAGS += -DHAVE_APPARMOR
	LDFLAGS += $(LIB_APPARMOR)
endif
endif

ifndef $(HAVE_KEYUTILS_H)
HAVE_KEYUTILS_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_keyutils_h)
ifeq ($(HAVE_KEYUTILS_H),1)
	CFLAGS += -DHAVE_KEYUTILS_H
endif
endif

ifndef $(HAVE_XATTR_H)
HAVE_XATTR_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_xattr_h)
ifeq ($(HAVE_XATTR_H),1)
	CFLAGS += -DHAVE_XATTR_H
endif
endif

ifndef $(HAVE_LIB_BSD)
HAVE_LIB_BSD = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_bsd)
ifeq ($(HAVE_LIB_BSD),1)
	CFLAGS += -DHAVE_LIB_BSD
	LDFLAGS += $(LIB_BSD)
endif
endif

ifndef $(HAVE_LIB_Z)
HAVE_LIB_Z = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_z)
ifeq ($(HAVE_LIB_Z),1)
	CFLAGS += -DHAVE_LIB_Z
	LDFLAGS += $(LIB_Z)
endif
endif

ifndef $(HAVE_LIB_CRYPT)
HAVE_LIB_CRYPT = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_crypt)
ifeq ($(HAVE_LIB_CRYPT),1)
	CFLAGS += -DHAVE_LIB_CRYPT
	LDFLAGS += $(LIB_CRYPT)
endif
endif

ifndef $(HAVE_LIB_RT)
HAVE_LIB_RT = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_rt)
ifeq ($(HAVE_LIB_RT),1)
	CFLAGS += -DHAVE_LIB_RT
	LDFLAGS += $(LIB_RT)
endif
endif

ifndef $(HAVE_LIB_PTHREAD)
HAVE_LIB_PTHREAD = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_pthread)
ifeq ($(HAVE_LIB_PTHREAD),1)
	CFLAGS += -DHAVE_LIB_PTHREAD
	LDFLAGS += $(LIB_PTHREAD)
endif
endif

ifndef $(HAVE_FLOAT_DECIMAL)
HAVE_FLOAT_DECIMAL = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_float_decimal)
ifeq ($(HAVE_FLOAT_DECIMAL),1)
	CFLAGS += -DHAVE_FLOAT_DECIMAL
endif
endif

ifndef $(HAVE_SECCOMP_H)
HAVE_SECCOMP_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_seccomp_h)
ifeq ($(HAVE_SECCOMP_H),1)
	CFLAGS += -DHAVE_SECCOMP_H
endif
endif

ifndef $(HAVE_LIB_AIO)
HAVE_LIB_AIO = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_aio)
ifeq ($(HAVE_LIB_AIO),1)
	CFLAGS += -DHAVE_LIB_AIO
	LDFLAGS += $(LIB_AIO)
endif
endif

ifndef $(HAVE_SYS_CAP_H)
HAVE_SYS_CAP_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_sys_cap_h)
ifeq ($(HAVE_SYS_CAP_H),1)
	CFLAGS += -DHAVE_SYS_CAP_H
endif
endif
endif



.SUFFIXES: .c .o

.o: stress-ng.h Makefile

.c.o: stress-ng.h Makefile $(SRC)
	@echo $(CC) $(CFLAGS) -c -o $@ $<
	@$(CC) $(CFLAGS) -c -o $@ $<

stress-ng: $(OBJS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -o $@

#
#  check if we can build against AppArmor
#
have_apparmor:
	@$(CC) $(CPPFLAGS) test-apparmor.c $(LIB_APPARMOR) -o test-apparmor 2> /dev/null || true
	@if [ -e test-apparmor ]; then \
		if [ -x $(APPARMOR_PARSER) ]; then \
			echo 1 ;\
		else \
			echo 0 ;\
		fi \
	else \
		echo 0 ;\
	fi
	@rm -f test-apparmor

#
#  check if we have keyutils.h
#
have_keyutils_h:
	@echo "#include <sys/types.h>" > test-key.c
	@echo "#include <keyutils.h>" >> test-key.c
	@$(CC) $(CPPFLAGS) -c -o test-key.o test-key.c 2> /dev/null || true
	@if [ -e test-key.o ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-key.c test-key.o

#
#  check if we have xattr.h
#
have_xattr_h:
	@echo "#include <sys/types.h>" > test-xattr.c
	@echo "#include <attr/xattr.h>" >> test-xattr.c
	@$(CC) $(CPPFLAGS) -c -o test-xattr.o test-xattr.c 2> /dev/null || true
	@if [ -e test-xattr.o ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-xattr.c test-xattr.o

#
#  check if we can build against libbsd
#
have_lib_bsd:
	@$(CC) $(CPPFLAGS) test-libbsd.c $(LIB_BSD) -o test-libbsd 2> /dev/null || true
	@if [ -e test-libbsd ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-libbsd

#
#  check if we can build against libz
#
have_lib_z:
	@$(CC) $(CPPFLAGS) test-libz.c $(LIB_Z) -o test-libz 2> /dev/null || true
	@if [ -e test-libz ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-libz

#
#  check if we can build against libcrypt
#
have_lib_crypt:
	@$(CC) $(CPPFLAGS) test-libcrypt.c $(LIB_CRYPT) -o test-libcrypt 2> /dev/null || true
	@if [ -e test-libcrypt ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-libcrypt

#
#  check if we can build against librt
#
have_lib_rt:
	@$(CC) $(CPPFLAGS) test-librt.c $(LIB_RT) -o test-librt 2> /dev/null || true
	@if [ -e test-librt ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-librt

#
#  check if we can build against libpthread
#
have_lib_pthread:
	@$(CC) $(CPPFLAGS) test-libpthread.c $(LIB_PTHREAD) -o test-libpthread 2> /dev/null || true
	@if [ -e test-libpthread ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-libpthread

#
#  check if compiler supports floating point decimal format
#
have_float_decimal:
	@echo "_Decimal32 x;" > test-decimal.c
	@$(CC) $(CPPFLAGS) -c -o test-decimal.o test-decimal.c 2> /dev/null || true
	@if [ -e test-decimal.o ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-decimal.c test-decimal.o

#
#  check if we have seccomp.h
#
have_seccomp_h:
	@echo "#include <linux/seccomp.h>" > test-seccomp.c
	@$(CC) $(CPPFLAGS) -c -o test-seccomp.o test-seccomp.c 2> /dev/null || true
	@if [ -e test-seccomp.o ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-seccomp.c test-seccomp.o

#
#  check if we can build against libaio
#
have_lib_aio:
	@$(CC) $(CPPFLAGS) test-libaio.c $(LIB_AIO) -o test-libaio 2> /dev/null || true
	@if [ -e test-libaio ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-libaio

#
#  generate apparmor data using minimal core utils tools from apparmor
#  parser output
#
apparmor-data.o: usr.bin.pulseaudio.eg
	$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin
	echo "#include <stddef.h>" > apparmor-data.c
	echo "char apparmor_data[]= { " >> apparmor-data.c
	od -tx1 -An -v < apparmor-data.bin | \
		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
		sed '$$ s/.$$//' >> apparmor-data.c
	echo "};" >> apparmor-data.c
	echo "const size_t apparmor_data_len = sizeof(apparmor_data);" >> apparmor-data.c
	$(CC) -c apparmor-data.c -o apparmor-data.o
	@rm -rf apparmor-data.c

#
#  check if we have sys/capability.h
#
have_sys_cap_h:
	@$(CC) $(CPPFLAGS) test-cap.c -o test-cap 2> /dev/null || true
	@if [ -e test-cap ]; then \
		echo 1 ;\
	else \
		echo 0 ;\
	fi
	@rm -f test-cap

#
#  extract the PER_* personality enums
#
personality.h:
	@$(CPP) personality.c | grep -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
	| sed "s/.$$/,/" > personality.h

stress-personality.c: personality.h

stress-cpu.o: stress-cpu.c
	@echo $(CC) $(CFLAGS) -c -o $@ $<
	@echo "_Decimal32 x;" > test-decimal.c
	@$(CC) $(CPPFLAGS) -c -o test-decimal.o test-decimal.c 2> /dev/null || true
	@if [ -e test-decimal.o ]; then \
		$(CC) $(CFLAGS) -DSTRESS_FLOAT_DECIMAL -c -o $@ $< ;\
	else \
		$(CC) $(CFLAGS) -c -o $@ $< ;\
	fi
	@rm -f test-decimal.c test-decimal.o

stress-str.o: stress-str.c
	@echo $(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
	@$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<

stress-wcstr.o: stress-wcstr.c
	@echo $(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
	@$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<

$(OBJS): stress-ng.h Makefile

stress-ng.1.gz: stress-ng.1
	gzip -c $< > $@

dist:
	rm -rf stress-ng-$(VERSION)
	mkdir stress-ng-$(VERSION)
	cp -rp Makefile $(SRC) stress-ng.h stress-ng.1 personality.c \
		COPYING syscalls.txt mascot README README.Android \
		test-apparmor.c test-libbsd.c test-libz.c \
		test-libcrypt.c test-librt.c test-libpthread.c \
		test-libaio.c test-cap.c usr.bin.pulseaudio.eg \
		stress-ng-$(VERSION)

=== debian/changelog ===
stress-ng (0.05.23-1ubuntu2) xenial; urgency=medium

  * Fix alignment mask to ensure stacks are 16 byte aligned (LP: #1573117)
    - incorrect mask used in previous fix, now using correct mask

 -- Colin King <colin.king@canonical.com>  Tue, 26 Apr 2016 12:16:47 +0100

stress-ng (0.05.23-1ubuntu1) xenial; urgency=medium

  * Ensure all clone() calls are 16 byte aligned for aarch64 (LP: #1573117)
  * stress-mmap: handle SIGBUS signals (LP: #1569468)

 -- Colin King <colin.king@canonical.com>  Fri, 22 Apr 2016 11:38:12 +0100

stress-ng (0.05.23-1) xenial; urgency=medium

  * Makefile: bump version
  * stress-aio: fix segfault on --maximumize option (LP: #1568335)
  * stress-chmod: just instance 0 should create the file (LP: #1568333)

 -- Colin King <colin.king@canonical.com>  Sat, 9 Apr 2016 17:48:23 +0100

stress-ng (0.05.22-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-af-alg: retry open if we get EAFNOSUPPORT (LP: #1564786)

 -- Colin King <colin.king@canonical.com>  Fri, 1 Apr 2016 09:40:56 +0100

stress-ng (0.05.21-1) unstable; urgency=medium

  * Makefile: bump version
  * Add test-cap.c to Makefile dist rule
  * debian: tests: don't run remap stressor
  * stress-ng: add klog (syslog) stressor
  * syscalls: add remap_file_pages
  * Add page remapping stressor
  * stress-pthread: Add get_robust_list call
  * stress-sysinfo: exercise fstatfs()
  * Move wcs options to correct postion in manual
  * Add the sync-file stressor
  * Add fp-error stressor
  * syscalls.txt: update some missing syscalls and some re-ordering
  * Add sys/capability.h and capget build time checks
  * stress-get: add prlimit
  * Update syscalls.txt with capget stressor
  * Add capabilities stressor

 -- Colin King <colin.king@canonical.com>  Sun, 20 Mar 2016 11:39:31 +0000

stress-ng (0.05.20-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-getdent: fix build warnings on systems with no getdents syscalls
  * Manual: update date
  * Debian/changelog: fix spelling mistake
  * stress-udp: fix two warnings on uninitialised addr
  * stress-socket-fd: fix two scan-build warnings
  * stress-getdent: init ret to -ENOSYS, fix scan-build warning
  * Use the generic signal handler helpers
  * helper: add generic signal handling/restoring helper functions
  * stress-oom-pipe: use stress_get_file_limit
  * stress-open: use stress_get_file_limit
  * stress-dup: use stress_get_file_limit
  * stress-socket-fd: use stress_get_file_limit
  * helper: add stress_get_file_limit to get max open files allowed
  * Add sockfd stressor
  * Add getdent stressor
  * stress-filename: use strncpy rather than strcpy
  * stress-qsort: use calloc
  * stress-cpu: zeta method should be counting in integers
  * stress-mergesort: use calloc
  * stress-heapsort: use calloc
  * stress-bsearch: use calloc

 -- Colin King <colin.king@canonical.com>  Sat, 12 Mar 2016 17:58:42 +0000

stress-ng (0.05.19-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-switch: don't initialize buf_size twice
  * stress-ng: don't stress-sleep options unless STRESS_SLEEP defined
  * stress-shm-sysv: comparing j < i - 1 is incorrect when i = 0
  * stress-shm-sysv: parent should close read end of pipe
  * stress-context: make stacks larger, avoid segfault on kFreeBSD
  * stress-oom-pipe: handle condition where pipe size can't be set
  * stress-pipe: use O_DIRECT when possible
  * stress-switch: use O_DIRECT with 1 byte buffer is possible
  * stress-oom-pipe: ensure sz is set before we check it against prev_sz
  * Add stress-oom-pipe pipe buffer stressor
  * helper: fix comment on system_read()
  * stress-fallocate: add in default mode 0
  * stress-iosync: fix build warning when using old glibc:
  * stress-fstat: add blacklist of paths not to open/fstat/close
  * correctly spell stress_adjust_pthread_max
  * stress-str: make some statics into static const
  * stress-socket: make socket_opts static const
  * stress-maxtrix: make some statics static const
  * stress-vm: make some statics static const
  * stress-wcstr: make variables static const
  * stress-get: make priorities static const
  * stress-filename: make filename_opts static const
  * stress-dentry: make dentry_removals static const
  * stress-cpu: make some variables static const
  * stress-clone: make flags and unshare flags static const
  * stress-chmod: make modes static const
  * perf: make perf_tp_info static const
  * cache: make struct generic_map const
  * helper: make stress_temp_path static const
  * stress-udp-flood: make data static const
  * stress-spawn: make exec strings static
  * Only define OPT_PTHREAD* macros if STRESS_PHREAD is defined
  * Minor #define changes, no functional change
  * stress-cpu: remove redundant initialisation of last_e
  * stress-cpu: don't build _Decimal stressors with clang
  * stress-shm-sysv: set entire shm_ids array to -1
  * stress-fork: make child exit immediately and stash pid only in parent
  * stress-xattr: free buffer on error exit path
  * stress-timerfd: fix timer thresholding check
  * Add sleep stressor
  * stress-clock: add some comments and make source 80 column friendly
  * bigheap: reorder some variables on the stack for better packing
  * Add whitespace in return statement
  * thermal-zone: minor clean up
  * net: make loop iterator size_t
  * cache: minor code tweaks, no functional changes
  * cache: rework get_contents error return paths
  * cache: reformat function declarations to match the stress-ng code style
  * clean up and rename macro mk_path to MK_PATH
  * Ensure we do not under run string buffer
  * Add apparmor_parser executable check
  * time: make source 80 column friendly
  * thermal-zone: make source 80 column friendly
  * sched: make source 80 column friendly
  * perf: make source 80 column friendly
  * mlock: make source 80 column friendly
  * limit.c: remove redundant #includes
  * io-priority: make source 80 column friendly
  * ignite-cpu: make source 80 column friendly


=== debian/control ===
Source: stress-ng
Section: devel
Priority: extra
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 3.9.6
Build-Depends: debhelper (>= 9), zlib1g-dev, libbsd-dev, libattr1-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
Homepage: http://kernel.ubuntu.com/~cking/stress-ng

Package: stress-ng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool to load and stress a computer
 stress-ng can stress various subsystems of a computer.  It can stress load
 CPU, cache, disk, memory, socket and pipe I/O, scheduling and much more.
 stress-ng is a re-write of the original stress tool by Amos Waterland but
 has many additional features such as specifying the number of bogo operations
 to run, execution metrics, a stress verification on memory and compute
 operations and considerably more stress mechanisms.

## stress-ng 0.06.17

=== Makefile ===
--- 
+++ 
@@ -16,12 +16,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.05.23
-#
-# Codename "dastardly determined distressor"
-#
-
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
+VERSION=0.06.17
+#
+# Codename "pathological process pounder"
+#
+
+CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99
 
 BINDIR=/usr/bin
 MANDIR=/usr/share/man/man1
@@ -35,6 +35,7 @@
 	stress-aio.c \
 	stress-aio-linux.c \
 	stress-apparmor.c \
+	stress-atomic.c \
 	stress-bigheap.c \
 	stress-bind-mount.c \
 	stress-brk.c \
@@ -43,6 +44,7 @@
 	stress-cap.c \
 	stress-chdir.c \
 	stress-chmod.c \
+	stress-chown.c \
 	stress-clock.c \
 	stress-clone.c \
 	stress-context.c \
@@ -67,6 +69,7 @@
 	stress-fork.c \
 	stress-fp-error.c \
 	stress-fstat.c \
+	stress-full.c \
 	stress-futex.c \
 	stress-get.c \
 	stress-getrandom.c \
@@ -77,6 +80,7 @@
 	stress-hsearch.c \
 	stress-icache.c \
 	stress-inotify.c \
+	stress-ioprio.c \
 	stress-iosync.c \
 	stress-itimer.c \
 	stress-kcmp.c \
@@ -87,8 +91,11 @@
 	stress-lsearch.c \
 	stress-link.c \
 	stress-lockbus.c \
+	stress-locka.c \
 	stress-lockf.c \
+	stress-lockofd.c \
 	stress-longjmp.c \
+	stress-madvise.c \
 	stress-malloc.c \
 	stress-matrix.c \
 	stress-membarrier.c \
@@ -103,12 +110,14 @@
 	stress-mmapmany.c \
 	stress-mremap.c \
 	stress-msg.c \
+	stress-msync.c \
 	stress-mq.c \
 	stress-nice.c \
 	stress-noop.c \
 	stress-null.c \
 	stress-numa.c \
 	stress-oom-pipe.c \
+	stress-opcode.c \
 	stress-open.c \
 	stress-personality.c \
 	stress-pipe.c \
@@ -116,6 +125,7 @@
 	stress-procfs.c \
 	stress-pthread.c \
 	stress-ptrace.c \
+	stress-pty.c \
 	stress-quota.c \
 	stress-qsort.c \
 	stress-rdrand.c \
@@ -123,8 +133,11 @@
 	stress-remap-file-pages.c \
 	stress-rename.c \
 	stress-rlimit.c \
+	stress-rtc.c \
+	stress-sctp.c \
+	stress-seal.c \
+	stress-seccomp.c \
 	stress-seek.c \
-	stress-seccomp.c \
 	stress-sem.c \
 	stress-sem-sysv.c \
 	stress-sendfile.c \
@@ -143,6 +156,7 @@
 	stress-spawn.c \
 	stress-splice.c \
 	stress-stack.c \
+	stress-stackmmap.c \
 	stress-str.c \
 	stress-stream.c \
 	stress-switch.c \
@@ -152,6 +166,7 @@
 	stress-tee.c \
 	stress-timer.c \
 	stress-timerfd.c \
+	stress-tlb-shootdown.c \
 	stress-tsc.c \
 	stress-tsearch.c \
 	stress-udp.c \
@@ -176,6 +191,7 @@
 # Stress core
 #
 CORE_SRC = \
+	affinity.c \
 	cache.c \
 	helper.c \
 	ignite-cpu.c \
@@ -208,10 +224,12 @@
 LIB_RT := -lrt
 LIB_PTHREAD := -lpthread
 LIB_AIO = -laio
+LIB_SCTP = -lsctp
 
 HAVE_NOT=HAVE_APPARMOR=0 HAVE_KEYUTILS_H=0 HAVE_XATTR_H=0 HAVE_LIB_BSD=0 \
 	 HAVE_LIB_Z=0 HAVE_LIB_CRYPT=0 HAVE_LIB_RT=0 HAVE_LIB_PTHREAD=0 \
-	 HAVE_FLOAT_DECIMAL=0 HAVE_SECCOMP_H=0 HAVE_LIB_AIO=0 HAVE_SYS_CAP_H=0
+	 HAVE_FLOAT_DECIMAL=0 HAVE_SECCOMP_H=0 HAVE_LIB_AIO=0 HAVE_SYS_CAP_H=0 \
+	 HAVE_VECMATH=0 HAVE_ATOMIC=0 HAVE_LIB_SCTP=0
 
 #
 # Do build time config only if cmd is "make" and no goals given
@@ -230,6 +248,10 @@
 endif
 endif
 
+ifeq ($(shell uname -s),SunOS)
+	LDFLAGS += -lsocket -lnsl
+endif
+
 ifndef $(HAVE_KEYUTILS_H)
 HAVE_KEYUTILS_H = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_keyutils_h)
 ifeq ($(HAVE_KEYUTILS_H),1)
@@ -284,6 +306,14 @@
 endif
 endif
 
+ifndef $(HAVE_LIB_SCTP)
+HAVE_LIB_SCTP = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_lib_sctp)
+ifeq ($(HAVE_LIB_SCTP),1)
+	CFLAGS += -DHAVE_LIB_SCTP
+	LDFLAGS += $(LIB_SCTP)
+endif
+endif
+
 ifndef $(HAVE_FLOAT_DECIMAL)
 HAVE_FLOAT_DECIMAL = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_float_decimal)
 ifeq ($(HAVE_FLOAT_DECIMAL),1)
@@ -312,9 +342,22 @@
 	CFLAGS += -DHAVE_SYS_CAP_H
 endif
 endif
-endif
-
-
+
+ifndef $(HAVE_VECMATH)
+HAVE_VECMATH = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_vecmath)
+ifeq ($(HAVE_VECMATH),1)
+	CFLAGS += -DHAVE_VECMATH
+endif
+endif
+
+ifndef $(HAVE_ATOMIC)
+HAVE_ATOMIC = $(shell $(MAKE) --no-print-directory $(HAVE_NOT) have_atomic)
+ifeq ($(HAVE_ATOMIC),1)
+	CFLAGS += -DHAVE_ATOMIC
+endif
+endif
+
+endif
 
 .SUFFIXES: .c .o
 
@@ -430,6 +473,19 @@
 		echo 0 ;\
 	fi
 	@rm -f test-libpthread
+
+#
+#  check if we can build against libsctp
+#
+have_lib_sctp:
+	@$(CC) $(CPPFLAGS) test-libsctp.c $(LIB_SCTP) -o test-libsctp 2> /dev/null || true
+	@if [ -e test-libsctp ]; then \
+		echo 1 ;\
+	else \
+		echo 0 ;\
+	fi
+	@rm -f test-libsctp
+
 
 #
 #  check if compiler supports floating point decimal format
@@ -498,44 +554,5 @@
 	@rm -f test-cap
 
 #
-#  extract the PER_* personality enums
-#
-personality.h:
-	@$(CPP) personality.c | grep -e "PER_[A-Z0-9]* =.*," | cut -d "=" -f 1 \
-	| sed "s/.$$/,/" > personality.h
-
-stress-personality.c: personality.h
-
-stress-cpu.o: stress-cpu.c
-	@echo $(CC) $(CFLAGS) -c -o $@ $<
-	@echo "_Decimal32 x;" > test-decimal.c
-	@$(CC) $(CPPFLAGS) -c -o test-decimal.o test-decimal.c 2> /dev/null || true
-	@if [ -e test-decimal.o ]; then \
-		$(CC) $(CFLAGS) -DSTRESS_FLOAT_DECIMAL -c -o $@ $< ;\
-	else \
-		$(CC) $(CFLAGS) -c -o $@ $< ;\
-	fi
-	@rm -f test-decimal.c test-decimal.o
-
-stress-str.o: stress-str.c
-	@echo $(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
-	@$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
-
-stress-wcstr.o: stress-wcstr.c
-	@echo $(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
-	@$(CC) $(CFLAGS) -fno-builtin -c -o $@ $<
-
-$(OBJS): stress-ng.h Makefile
-
-stress-ng.1.gz: stress-ng.1
-	gzip -c $< > $@
-
-dist:
-	rm -rf stress-ng-$(VERSION)
-	mkdir stress-ng-$(VERSION)
-	cp -rp Makefile $(SRC) stress-ng.h stress-ng.1 personality.c \
-		COPYING syscalls.txt mascot README README.Android \
-		test-apparmor.c test-libbsd.c test-libz.c \
-		test-libcrypt.c test-librt.c test-libpthread.c \
-		test-libaio.c test-cap.c usr.bin.pulseaudio.eg \
-		stress-ng-$(VERSION)
+#  check if we can build vecmath related code
+#

=== snapcraft/Makefile ===
VERSION=$(shell git tag | tail -1 | cut -c2-)
COMMITS=$(shell git log --oneline | wc -l)
SHA=$(shell git log -1 --oneline | cut -d' ' -f1)
DATE=$(shell date +'%Y%m%d')
V=$(VERSION)-$(DATE)-$(COMMITS)-$(SHA)

all: get_icon set_version
	snapcraft

set_version:
	cat snapcraft.yaml | sed 's/version: .*/version: $(V)/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

get_icon: 
	@if [ ! -e setup/gui/icon.svg ]; \
	then \
		echo copying icon.svg; \
		mkdir -p setup/gui; \
		cp ../mascot/stress-ng.svg setup/gui/icon.svg; \
	fi;

clean:
	rm -rf setup *.snap
	snapcraft clean
	cat snapcraft.yaml | sed 's/version: .*/version: 0/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

=== debian/changelog ===
stress-ng (0.06.17-1ubuntu3) yakkety; urgency=medium

  * Actually include the patches for the following fixes (previous upload didn't
    have them).
  - stress-opcode: unmap the shared region to avoid clobbering it (LP: #1632989)
  - stress-icache: ensure we mprotect on page aligned boundary (LP: #1632991)

 -- Colin King <colin.king@canonical.com>  Thu, 13 Oct 2016 10:13:00 +0100

stress-ng (0.06.17-1ubuntu2) yakkety; urgency=medium

  * stress-opcode: unmap the shared region to avoid clobbering it (LP: #1632989)
  * stress-icache: ensure we mprotect on page aligned boundary (LP: #1632991)

 -- Colin King <colin.king@canonical.com>  Thu, 13 Oct 2016 09:46:09 +0100

stress-ng (0.06.17-1ubuntu1) yakkety; urgency=medium

  * stress-rtc: handle return code correctly and -EINTR (LP: #1630649)
  * stress-oom-pipe: fix pipe fd offset bug (LP: #1630647)
    - fixes writes to fd 0 on ppc64el and not all fd's are being
      set with fcntl() as expected.
  * add padding around rtc_tm to workaround an ioctl bug (LP: #1630646)

 -- Colin King <colin.king@canonical.com>  Wed, 5 Oct 2016 16:57:17 +0100

stress-ng (0.06.17-1ubuntu0) yakkety; urgency=medium

  * stress-procfs/sysfs: abort on read errors (LP: #1629843)
    - EINTR and EAGAIN errors were doing re-reads and this can get
      stuck forever for example on some procfs files and when SIGALRM
      occurred, so don't re-read, just abort the reads.

 -- Colin King <colin.king@canonical.com>  Mon, 3 Oct 2016 12:25:34 +0100

stress-ng (0.06.17-1) unstable; urgency=medium

  * Makefile: bump version
  * Update manual to explain the caveats with --perf
  * perf: detect when perf counters can't be used (LP: #1626009)
    - add better explanation on how to enable --perf as
      an unprivileged user

 -- Colin King <colin.king@canonical.com>  Wed, 21 Sep 2016 10:25:17 +0100

stress-ng (0.06.16-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: add test-libsctp.c to make dist rule
  * test-libcrypt: fix cppcheck warning
  * Debian/control: add libgcrypt11-dev
  * stress-procfs: clear stack before use
  * manual: update date
  * stress-sysfs: only report an info message on instance 0
  * test-libsctp: add some checks for required macros
  * sched: fix build warning when building with clang on minix
  * sched: fix build warning when building with clang on minix
  * stress-stack: fix build warning when building with clang on minix
  * stress-mmap: fix build warning when building with clang on minix
  * stress-get: fix build warning with clang on minix
  * stress-sctp: add in missing --sctp-domain option, update manual
  * Update net helper to add addresses, add new SCTP stressor
  * Some minor cleanups to main stress-ng header, nothing major
  * rename get_unsigned_long to get_uint32
  * Some more 80 column source line width fixes
  * stress-sysfs: use fstat rather than access on path
  * stress-procfs: forgot to re-open closed file
  * stress-procfs: add some illegal read calls to try to break procfs
  * stress-sysfs: add some illegal read calls to try to break sysfs
  * Make snapcraft confinement devmode
  * Minor formatting changes to ensure 80 column wide source
  * stress-tlb-shootdown: fix indentation
  * stress-context: don't build with sigaltstack if minix or hurd
  * stress-context: add use of sigaltstack and SS_AUTODISARM
  * helper: fix indentation
  * stress-opcode: fix indentation
  * stress-ioprio: remove duplicate and badly indented umask() call
  * stress-epoll: fix indentation on if statement
  * helper: set core size to zero if possible with setrlimit
  * helper: force number of cpus to be 1 if sysconf not available
  * net: declare missing in6addr_any for minix
  * stress-mmap: make mprotect a no-op for minix
  * stress-mmap: don't use msync for minix
  * stress-shm-sysv: don't use msync for minix
  * stress-stack: don't use sigaltstack for minix
  * sched: make this a no-op for minix
  * mlock: make this a no-op for minix
  * don't enable STRESS_MSYNC for minix
  * don't enable STRESS_YIELD for minix
  * stress-flock: don't yield if minix
  * mincore: make this a no-op for minix
  * madvise: this is a no-op for minix
  * stress-mlock: don't build for minix
  * stress-cpu: minix does not support cabsl, use cabs instead
  * stress-hdd: don't do madvise for minix
  * stress-get: minix does not have getpgrp()
  * stress-ng.h: don't build in mlock stressor if minix
  * forgot to guard MLOCK stressor with STRESS_MLOCK check
  * stress-get: minix does not have getpgid()
  * mounts: fix build issues for minix
  * mincore: fix build warning on minix
  * stress-ng.h: only include <pthread.h> if it is available
  * stress-wait: cater for systems that lack WCONTINUED
  * stress-sigsuspend: remove <pthread.h> header inclusion, not required
  * stress-quota: make err local to each code block
  * stress-quota: remove redundant err assignment
  * stress-quota: rename local errno so we don't alias global errno
  * stress-quota: fix cppcheck style warning
  * stress-madvise: fix cppcheck style warning
  * stress-clock: fix cppcheck style warning
  * stress-sysfs: fix cppcheck style warning, initialize stack
  * stress-ng: clarify precedence of & and ?, fixes cppcheck style warnings
  * stress-handle: ensure scanf %s field is limited to avoid overruns
  * Fix SunOS builds, add socket and nsl library link flags
  * Use mfence instead of __sync_synchronize for gcc pre 4.2 on x86
  * Makefile: explicitly specify C standard using --std=gnu99
  * stress-vm: don't use binary constants, gcc may not support these

 -- Colin King <colin.king@canonical.com>  Fri, 16 Sep 2016 16:15:48 +0100

stress-ng (0.06.15-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-af-alg: account for number of ENOENT crypto bind failures
  * stress-af-alg: don't report bind on ENOENT as a failure (LP: #1617788)
    - retry is performed, failures are accounted for in debug verbose -v mode



## stress-ng 0.07.13

=== Makefile ===
--- 
+++ 
@@ -16,12 +16,29 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.06.17
-#
-# Codename "pathological process pounder"
+VERSION=0.07.13
+#
+# Codename "systematic stress inducer"
 #
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -std=gnu99
+
+#
+# Pedantic flags
+#
+ifeq ($(PEDANTIC),1)
+CFLAGS += -Wabi -Wcast-qual -Wfloat-equal -Wmissing-declarations \
+	-Wmissing-format-attribute -Wno-long-long -Wpacked \
+	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
+	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
+endif
+
+#
+# Static flags, only to be used when using GCC
+#
+ifeq ($(STATIC),1)
+LDFLAGS += -static
+endif
 
 BINDIR=/usr/bin
 MANDIR=/usr/share/man/man1
@@ -53,8 +70,11 @@
 	stress-cpu-online.c \
 	stress-crypt.c \
 	stress-daemon.c \
+	stress-dccp.c \
 	stress-dentry.c \
 	stress-dir.c \
+	stress-dirdeep.c \
+	stress-dnotify.c \
 	stress-dup.c \
 	stress-epoll.c \
 	stress-eventfd.c \
@@ -79,6 +99,7 @@
 	stress-heapsort.c \
 	stress-hsearch.c \
 	stress-icache.c \
+	stress-icmp-flood.c \
 	stress-inotify.c \
 	stress-ioprio.c \
 	stress-iosync.c \
@@ -132,9 +153,12 @@
 	stress-readahead.c \
 	stress-remap-file-pages.c \
 	stress-rename.c \
+	stress-resources.c \
 	stress-rlimit.c \
+	stress-rmap.c \
 	stress-rtc.c \
 	stress-sctp.c \
+	stress-schedpolicy.c \
 	stress-seal.c \
 	stress-seccomp.c \
 	stress-seek.c \
@@ -208,8 +232,10 @@
 	parse-opts.c \
 	perf.c \
 	sched.c \
+	shim.c \
 	thermal-zone.c \
 	time.c \
+	thrash.c \
 	stress-ng.c
 
 SRC = $(STRESS_SRC) $(CORE_SRC)
@@ -368,15 +394,15 @@
 	@$(CC) $(CFLAGS) -c -o $@ $<
 
 stress-ng: $(OBJS)
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -o $@
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(OBJS) -lm $(LDFLAGS) -lc -o $@
 
 #
 #  check if we can build against AppArmor
 #
 have_apparmor:
 	@$(CC) $(CPPFLAGS) test-apparmor.c $(LIB_APPARMOR) -o test-apparmor 2> /dev/null || true
-	@if [ -e test-apparmor ]; then \
-		if [ -x $(APPARMOR_PARSER) ]; then \
+	@if [ -f test-apparmor ]; then \
+		if [ -x "$(APPARMOR_PARSER)" ]; then \
 			echo 1 ;\
 		else \
 			echo 0 ;\
@@ -393,7 +419,7 @@
 	@echo "#include <sys/types.h>" > test-key.c
 	@echo "#include <keyutils.h>" >> test-key.c
 	@$(CC) $(CPPFLAGS) -c -o test-key.o test-key.c 2> /dev/null || true
-	@if [ -e test-key.o ]; then \
+	@if [ -f test-key.o ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -407,7 +433,7 @@
 	@echo "#include <sys/types.h>" > test-xattr.c
 	@echo "#include <attr/xattr.h>" >> test-xattr.c
 	@$(CC) $(CPPFLAGS) -c -o test-xattr.o test-xattr.c 2> /dev/null || true
-	@if [ -e test-xattr.o ]; then \
+	@if [ -f test-xattr.o ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -419,7 +445,7 @@
 #
 have_lib_bsd:
 	@$(CC) $(CPPFLAGS) test-libbsd.c $(LIB_BSD) -o test-libbsd 2> /dev/null || true
-	@if [ -e test-libbsd ]; then \
+	@if [ -f test-libbsd ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -431,7 +457,7 @@
 #
 have_lib_z:
 	@$(CC) $(CPPFLAGS) test-libz.c $(LIB_Z) -o test-libz 2> /dev/null || true
-	@if [ -e test-libz ]; then \
+	@if [ -f test-libz ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -443,7 +469,7 @@
 #
 have_lib_crypt:
 	@$(CC) $(CPPFLAGS) test-libcrypt.c $(LIB_CRYPT) -o test-libcrypt 2> /dev/null || true
-	@if [ -e test-libcrypt ]; then \
+	@if [ -f test-libcrypt ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -455,7 +481,7 @@
 #
 have_lib_rt:
 	@$(CC) $(CPPFLAGS) test-librt.c $(LIB_RT) -o test-librt 2> /dev/null || true
-	@if [ -e test-librt ]; then \
+	@if [ -f test-librt ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -467,7 +493,7 @@
 #
 have_lib_pthread:
 	@$(CC) $(CPPFLAGS) test-libpthread.c $(LIB_PTHREAD) -o test-libpthread 2> /dev/null || true
-	@if [ -e test-libpthread ]; then \
+	@if [ -f test-libpthread ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -479,7 +505,7 @@
 #
 have_lib_sctp:
 	@$(CC) $(CPPFLAGS) test-libsctp.c $(LIB_SCTP) -o test-libsctp 2> /dev/null || true
-	@if [ -e test-libsctp ]; then \
+	@if [ -f test-libsctp ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -493,7 +519,7 @@
 have_float_decimal:
 	@echo "_Decimal32 x;" > test-decimal.c
 	@$(CC) $(CPPFLAGS) -c -o test-decimal.o test-decimal.c 2> /dev/null || true
-	@if [ -e test-decimal.o ]; then \
+	@if [ -f test-decimal.o ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -506,7 +532,7 @@
 have_seccomp_h:
 	@echo "#include <linux/seccomp.h>" > test-seccomp.c
 	@$(CC) $(CPPFLAGS) -c -o test-seccomp.o test-seccomp.c 2> /dev/null || true
-	@if [ -e test-seccomp.o ]; then \
+	@if [ -f test-seccomp.o ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -518,7 +544,7 @@
 #
 have_lib_aio:
 	@$(CC) $(CPPFLAGS) test-libaio.c $(LIB_AIO) -o test-libaio 2> /dev/null || true
-	@if [ -e test-libaio ]; then \
+	@if [ -f test-libaio ]; then \
 		echo 1 ;\
 	else \
 		echo 0 ;\
@@ -533,26 +559,3 @@
 	$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin
 	echo "#include <stddef.h>" > apparmor-data.c
 	echo "char apparmor_data[]= { " >> apparmor-data.c
-	od -tx1 -An -v < apparmor-data.bin | \
-		sed 's/[0-9a-f][0-9a-f]/0x&,/g' | \
-		sed '$$ s/.$$//' >> apparmor-data.c
-	echo "};" >> apparmor-data.c
-	echo "const size_t apparmor_data_len = sizeof(apparmor_data);" >> apparmor-data.c
-	$(CC) -c apparmor-data.c -o apparmor-data.o
-	@rm -rf apparmor-data.c
-
-#
-#  check if we have sys/capability.h
-#
-have_sys_cap_h:
-	@$(CC) $(CPPFLAGS) test-cap.c -o test-cap 2> /dev/null || true
-	@if [ -e test-cap ]; then \
-		echo 1 ;\
-	else \
-		echo 0 ;\
-	fi
-	@rm -f test-cap
-
-#
-#  check if we can build vecmath related code
-#

## stress-ng 0.07.16

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2013-2016 Canonical, Ltd.
+# Copyright (C) 2013-2017 Canonical, Ltd.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -16,7 +16,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
 
-VERSION=0.07.13
+VERSION=0.07.16
 #
 # Codename "systematic stress inducer"
 #
@@ -86,6 +86,7 @@
 	stress-fifo.c \
 	stress-filename.c \
 	stress-flock.c \
+	stress-fanotify.c \
 	stress-fork.c \
 	stress-fp-error.c \
 	stress-fstat.c \
@@ -133,6 +134,7 @@
 	stress-msg.c \
 	stress-msync.c \
 	stress-mq.c \
+	stress-netlink-proc.c \
 	stress-nice.c \
 	stress-noop.c \
 	stress-null.c \
@@ -200,6 +202,7 @@
 	stress-userfaultfd.c \
 	stress-utime.c \
 	stress-vecmath.c \
+	stress-vforkmany.c \
 	stress-vm.c \
 	stress-vm-rw.c \
 	stress-vm-splice.c \
@@ -557,5 +560,3 @@
 #
 apparmor-data.o: usr.bin.pulseaudio.eg
 	$(APPARMOR_PARSER) -Q usr.bin.pulseaudio.eg  -o apparmor-data.bin
-	echo "#include <stddef.h>" > apparmor-data.c
-	echo "char apparmor_data[]= { " >> apparmor-data.c

=== snapcraft/Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	cat snapcraft.yaml | sed 's/version: .*/version: $(V)/' > snapcraft-tmp.yaml
 	mv snapcraft-tmp.yaml snapcraft.yaml
 
-get_icon: 
+get_icon:
 	@if [ ! -e setup/gui/icon.svg ]; \
 	then \
 		echo copying icon.svg; \

=== debian/changelog ===
stress-ng (0.07.16-1) unstable; urgency=medium

  * Makefile: bump version
  * fast-test-all: remove vforkmany, this can be aborted by the OS
  * stress-numa: abort when no NUMA nodes found with EXIT_NO_RESOURCE
  * stress-numa: make determining number of nodes non-fatal
  * stress-numa: correctly deduce number of available NUMA memory
    nodes (LP: #1656419)
  * stress-*: make all pr_inf info messages write to stdout and not stderr
  * stress-numa: add some info about number of NUMA nodes found
  * stress-numa: add in better error failure abort and error return
  * stress-numa: probe for maximum number of NUMA nodes
  * stress-wcstr: fix build error for stress_wcscpy
  * stress-wcs: fix wcslcpy and wcslcat test cases
  * stress-wcs: improve failure detection, bail out early if tests fail
  * stress-str: fix strlcpy and strlcat test cases
  * stress-str: improve failure detection, bail out early if tests fail
  * stress-seccomp: add openat to system calls to fix failure on aarch64
  * stress-seccomp: use pr_fail for seccomp errors

 -- Colin King <colin.king@canonical.com>  Fri, 20 Jan 2017 19:44:11 +0000

stress-ng (0.07.15-1) unstable; urgency=medium

  * Makefile: bump version
  * fast-test-all: use --stressors to get the list of stressors
  * stress-ng: fix typo in tlb-shootdown-ops option
  * stress-ng: correct the alphabetical order of stressor names
  * fast-test-all: sync before running next test
  * mounts: cater for *BSD mount info fetching
  * stress-netlink-proc.c: fix build issue on non-Linux systems
  * Fix build issue introduced in commit 39025068b1fe1c2a72220
  * stress-ng.h: remove double line spacing, add some comments
  * Manual: update contributors list
  * stress-rename: fix incorrect end of test logic
  * stress-ng: minor cleanup of spacing, some inlining and comments
  * Remove white space and replace ^ . with \t
  * Forgot to add in stress-netlink-proc.c
  * Add netlink-proc stressor
  * stress-rlimit: force checking of run time in case we miss SIGALRM

 -- Colin King <colin.king@canonical.com>  Tue, 17 Jan 2017 13:43:22 +0000

stress-ng (0.07.14-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update date
  * stress-socketpair: make stress_sockpair_oomable static
  * stress-socketpair: detect an oom-killed stressor
  * helper: don't use prctl PR_SET_DUMPABLE, it disables oom adjustment
    and hence we can easily overcommit when running as root (LP: #1654971)
  * out-of-memory: use /proc/self/... rather than /proc/$mypid/...
  * helper: use /proc/self/... rather than /proc/$mypid/...
  * stress-hsearch: don't free keys, some don't free them in hdelete
  * stress-vforkmany: use sighandler alternative stack
  * stress-context: make stack_sig static
  * Makefile: remove -g flag
  * stress-itimer: initialise start time
  * Add new --vforkmany stressor
  * stress-fanotify: ensure stress_fanotify_supported is built
  * Add fanotify stressor
  * Expand --get option in manual
  * stress-get: don't verify on adjtimex if not root, add sysfs calls
  * Add sysfs(2) shim wrapper
  * stress-membarrier: also exercise CMD QUERY
  * stress-dccp: report correct errno from connect failure
  * Makefile: update copyright year
  * update copyright year

 -- Colin King <colin.king@canonical.com>  Tue, 10 Jan 2017 15:32:10 +0000

stress-ng (0.07.13-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: rename check rule to fast-check-all
  * manual: update date
  * stress-udp: fix build warning on minix
  * stress-mmap: fix build issue with ms_flags on GNU/HURD and minix
  * add a make check rule to run debian/tests/fast-test-all
  * stress-pthread: add error checking on cond, mutex and spinlock init
  * add shim abstraction to msync, use this on various stressors
  * stress-pthread: check for init failures and use a spinlock on counter
  * add new dirdeep max depth directory stressor
  * README: Update info on libraries required for a full build
  * stress-cpu: fix missing bogo ops counter increment
  * enforce 64 byte alignment to buffer
  * stress-futex: fix typo in comment
  * ensure stacks are aligned to 64 byte boundaries
  * stress-hdd: use new align_address helper
  * helper: add align_address helper to align a address to power of 2 boundary
  * stress-sysinfo: only dump out info on number of mount points on instance 0
  * trivial typo in man page

 -- Colin King <colin.king@canonical.com>  Tue, 27 Dec 2016 19:40:19 +0000

stress-ng (0.07.12-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-udp: minix fails on setsockopt SO_REUSEADDR, so ignore it
  * stress-get: don't use NULL delta, just pass a zero delta timeval struct
  * stress-fifo: catch EINTR as non-fatal error on open
  * stress-resources: fix warning message on unused parameter 'pipe_size'
  * debian/tests: remove dccp from fast-test-all
  * helper: fix build issues on non-linux targets
  * update date in the manual
  * stress-resources: add pty resource suckage
  * stress-resources: add inotify resource suckage
  * stress-resources: try to expande pipe to maximum allowed size
  * stress-oom-pipe: use stress_probe_max_pipe_size helper
  * helper: add stress_probe_max_pipe_size to fine max pipe size
  * Add Datagram Congestion Control Protocol dccp stressor
  * stress-resources: add single pthread as another resource hogger
  * ensure -v output is no wider than 80 chars to avoid line wrap on std tty
  * stress-schedpolicy: set policy with param, remove unused new_param

 -- Colin King <colin.king@canonical.com>  Mon, 19 Dec 2016 14:33:23 +0000

stress-ng (0.07.11-1) unstable; urgency=medium

  * Makefile: bump version
  * thrash: bump the priority to 10
  * thrash: use RR scheduler if possible on linux
  * stress-sctp: don't unlink on an address that is NULL
  * stress-schedpolicy: the set/get param was a bit unsound, fix it
  * stress-fault: silence a clang warning
  * stress-membarrier: pass thread arg as a ctxt_t * type


=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: devel
 Priority: extra
 Maintainer: Colin King <colin.king@canonical.com>
-Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9), zlib1g-dev, libbsd-dev, libattr1-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
+Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 9), zlib1g-dev, libbsd-dev, libattr1-dev, libgcrypt11-dev, libkeyutils-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libapparmor-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], apparmor [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libaio-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64], libsctp-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64]
 Homepage: http://kernel.ubuntu.com/~cking/stress-ng
 
 Package: stress-ng
